////////////////////////////////////////////////////////////////////////////////
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2005 Xilinx, Inc.
//     All rights reserved.
// 
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Filename:     gpio.c
// 
// Description:   GPIO Interface Module 
// 
//-----------------------------------------------------------------------------

#include "xbasic_types.h"
#include "xpseudo_asm.h"
#include "sleep.h"
// Keep a copy of the most recent value written to the output port
static Xuint32 outval32; 

// Define input and output addresses
#define IN_PORT        0x01000000
#define OUT_PORT       0x3F1

#define LCD_MASK      0xFFFFFF80
#define LCD_OFFSET    0

static inline void Out32(Xuint32 val, Xuint32 mask, Xuint32 shift)
{
  outval32 = (outval32 & mask) | (val << shift);
  mtdcr(0x3F1, outval32);
}

void reset_rx_fifo(){
  Out32(0x80000000, 0x7FFFFFFF, 0);
  Out32(0x00000000, 0x7FFFFFFF, 0);
}
void reset_phy_ethernet(){
  usleep(1000000);
  Out32(0x00000000, 0xbFFFFFFF, 0);
  usleep(1000000);
  Out32(0x40000000, 0xbFFFFFFF, 0);
  usleep(1000000);
}
void lock_tx_fifo(){
  Out32(0x00000000, 0xdfffffff, 0);
}
void unlock_tx_fifo(){
  Out32(0x20000000, 0xdfffffff, 0);
}
void GPIO_writeLCD( Xuint32 data )
{
  Out32(data, LCD_MASK, LCD_OFFSET);
} 
