////////////////////////////////////////////////////////////////////////////////
//
//     XILINX IS PROVIDING THIS DESIGN, CODE, OR INFORMATION "AS IS"
//     SOLELY FOR USE IN DEVELOPING PROGRAMS AND SOLUTIONS FOR
//     XILINX DEVICES.  BY PROVIDING THIS DESIGN, CODE, OR INFORMATION
//     AS ONE POSSIBLE IMPLEMENTATION OF THIS FEATURE, APPLICATION
//     OR STANDARD, XILINX IS MAKING NO REPRESENTATION THAT THIS
//     IMPLEMENTATION IS FREE FROM ANY CLAIMS OF INFRINGEMENT,
//     AND YOU ARE RESPONSIBLE FOR OBTAINING ANY RIGHTS YOU MAY REQUIRE
//     FOR YOUR IMPLEMENTATION.  XILINX EXPRESSLY DISCLAIMS ANY
//     WARRANTY WHATSOEVER WITH RESPECT TO THE ADEQUACY OF THE
//     IMPLEMENTATION, INCLUDING BUT NOT LIMITED TO ANY WARRANTIES OR
//     REPRESENTATIONS THAT THIS IMPLEMENTATION IS FREE FROM CLAIMS OF
//     INFRINGEMENT, IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
//     FOR A PARTICULAR PURPOSE.
//     
//     (c) Copyright 2005 Xilinx, Inc.
//     All rights reserved.
// 
//----------------------------------------------------------------------------
//----------------------------------------------------------------------------

//----------------------------------------------------------------------------
// Filename:     sim_sleep.c
// 
// Description:    
// This file is used to reduce the time needed to simulate the usleep function.
// When this source file is compiled along with user source files the usleep
// call does not implement a timer based delay, usleep will simply return.
//
// Design Notes:
//   
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
// Xilinx APD
// History:
// 
//
//-----------------------------------------------------------------------------

#include "sleep.h"
#include "xtime_l.h"
#include "xparameters.h"

void nanosleep(unsigned int nanoseconds)
{
  /* not implemented */
}

void usleep(unsigned int useconds)
{
// Commented out for simulation, which need no delays. The Insight board 
// requires these delays which are built into EDK. Adding this file to your 
// project overrides the usleep lib in EDK and allows you to see the simulation
// results without a really long simulation of the delays 	
//
// To use the simulator, include this file 
// To use the Insight board, do not include this file
//
/*	{
		XTime tEnd, tCur;

		XTime_GetTime(&tCur);
		tEnd = tCur + ((XTime) useconds) * (XPAR_CPU_PPC405_CORE_CLOCK_FREQ_HZ / 1000000); 
		do
		{
			XTime_GetTime(&tCur);
		} while (tCur < tEnd);
	}*/
}

void sleep(unsigned int seconds)
{
  XTime tEnd, tCur;

  XTime_GetTime(&tCur);
  tEnd  = tCur + ((XTime) seconds) * XPAR_CPU_PPC405_CORE_CLOCK_FREQ_HZ;
  do
  {
    XTime_GetTime(&tCur);
  } while (tCur < tEnd);
}

